 gui = require('Gspot')
 serialize = require 'ser'
 socket = require("socket")
 Wins = 0
 Loses = 0
 r = 255
 g = 0
 b = 0
 aim = 0
 power1 = 1
 power2 = 1
 Menu = true
 Mode = 0
function saveGame()
    local data = {} -- Make a table to store variables in.

    data.Wins = Wins
    data.Loses = Loses
    data.power1 = power1
    data.power2 = power2
    data.r = r
    data.g = g
    data.b = b

    -- Save the table to the "savegame.txt" file:
    love.filesystem.write("savegame.txt", serialize(data))
end

function loadGame() 
    -- Do not load the game if the "savegame.txt" file doesn't exist:
    if not love.filesystem.exists("savegame.txt") then
        return
    end

    -- Load the data table:
    local data = love.filesystem.load("savegame.txt")()

    -- Copy the variables out of the table:
    Wins = data.Wins
    Loses = data.Loses
    power1 = data.power1
    power2 = data.power2
    r = data.r
    g = data.g
    b = data.b
end

function startGame(mode)
	Winner = ""
	if world ~= nil then world:destroy() end
	  world = love.physics.newWorld(0, 9.81*64, true)
	      	width = love.graphics.getWidth( )
  love.physics.setMeter(64)
	  objects = {}
	  allBullets = {}
	objects.ground = {}
  objects.ground.body = love.physics.newBody(world, width/2, love.graphics.getHeight()-50/2)
  objects.ground.shape = love.physics.newRectangleShape(love.graphics.getWidth() + 800, 50)
  objects.ground.fixture = love.physics.newFixture(objects.ground.body, objects.ground.shape);

  --let's create a ball
  objects.ball = {}
  objects.ball.body = love.physics.newBody(world, 50, 650/2, "dynamic")
  objects.ball.shape = love.physics.newCircleShape(20)
  objects.ball.fixture = love.physics.newFixture(objects.ball.body, objects.ball.shape, 1)
  objects.ball.fixture:setRestitution(0.15)

  objects.ball2 = {}
  objects.ball2.body = love.physics.newBody(world, width - 50, 650/2, "dynamic")
  objects.ball2.shape = love.physics.newCircleShape(20)
  objects.ball2.fixture = love.physics.newFixture(objects.ball2.body, objects.ball2.shape, 1)
  objects.ball2.fixture:setRestitution(0.15)

  objects.wall2 = {}
  objects.wall2.body = love.physics.newBody(world, love.graphics.getWidth(), love.graphics.getHeight()-900, "static")
  objects.wall2.shape = love.physics.newRectangleShape(0, 0, 100, 1000)
  objects.wall2.fixture = love.physics.newFixture(objects.wall2.body, objects.wall2.shape, 5)
 
  objects.wall1 = {}
  objects.wall1.body = love.physics.newBody(world, 0, love.graphics.getHeight()-900, "static")
  objects.wall1.shape = love.physics.newRectangleShape(0, 0, 100, 1000)
  objects.wall1.fixture = love.physics.newFixture(objects.wall1.body, objects.wall1.shape, 5)
  guiG:hide()
  custommenu:hide()
  pai = math.random(2, 6)
  Menu = false
  Mode = mode
end

function drawnorm()
    love.graphics.setColor(72, 160, 14)
  love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints()))

  love.graphics.setColor(r, g, b)
  love.graphics.circle("fill", objects.ball.body:getX(), objects.ball.body:getY(), objects.ball.shape:getRadius())
  
  love.graphics.setColor(14, 47, 193)
  love.graphics.circle("fill", objects.ball2.body:getX(), objects.ball2.body:getY(), objects.ball2.shape:getRadius())

  love.graphics.setColor(50, 50, 50)
  love.graphics.polygon("fill", objects.wall2.body:getWorldPoints(objects.wall2.shape:getPoints()))
  love.graphics.polygon("fill", objects.wall1.body:getWorldPoints(objects.wall1.shape:getPoints()))
  if cooldown1 == 0 then
    if power1 == 1 then
  love.graphics.draw(p1, objects.ball.body:getX(), objects.ball.body:getY())
  elseif power1 == 2 then
  love.graphics.draw(p2, objects.ball.body:getX(), objects.ball.body:getY())
    elseif power1 == 3 then
  love.graphics.draw(p3, objects.ball.body:getX(), objects.ball.body:getY())
      elseif power1 == 4 then
  love.graphics.draw(p4, objects.ball.body:getX(), objects.ball.body:getY())
        elseif power1 == 5 then
  love.graphics.draw(p5, objects.ball.body:getX(), objects.ball.body:getY())
elseif power1 == 6 then
    love.graphics.draw(p6, objects.ball.body:getX(), objects.ball.body:getY())
      end
elseif cooldown1 ~= 0 then
    if power1 == 1 then
  love.graphics.draw(p1c, objects.ball.body:getX(), objects.ball.body:getY())
  elseif power1 == 2 then
  love.graphics.draw(p2c, objects.ball.body:getX(), objects.ball.body:getY())
    elseif power1 == 3 then
  love.graphics.draw(p3c, objects.ball.body:getX(), objects.ball.body:getY())
      elseif power1 == 4 then
  love.graphics.draw(p4c, objects.ball.body:getX(), objects.ball.body:getY())
        elseif power1 == 5 then
  love.graphics.draw(p5c, objects.ball.body:getX(), objects.ball.body:getY())
  elseif power1 == 6 then
      love.graphics.draw(p6c, objects.ball.body:getX(), objects.ball.body:getY())
      end
end
if Mode ~= 4 then
  if cooldown2 == 0 then
    if power2 == 1 then
  love.graphics.draw(p1, objects.ball2.body:getX(), objects.ball2.body:getY())
  elseif power2 == 2 then
  love.graphics.draw(p2, objects.ball2.body:getX(), objects.ball2.body:getY())
    elseif power2 == 3 then
  love.graphics.draw(p3, objects.ball2.body:getX(), objects.ball2.body:getY())
      elseif power2 == 4 then
  love.graphics.draw(p4, objects.ball2.body:getX(), objects.ball2.body:getY())
        elseif power2 == 5 then
  love.graphics.draw(p5, objects.ball2.body:getX(), objects.ball2.body:getY())
  elseif power2 == 6 then
      love.graphics.draw(p6, objects.ball2.body:getX(), objects.ball2.body:getY())
      end
elseif cooldown2 ~= 0 then
    if power2 == 1 then
  love.graphics.draw(p1c, objects.ball2.body:getX(), objects.ball2.body:getY())
  elseif power2 == 2 then
  love.graphics.draw(p2c, objects.ball2.body:getX(), objects.ball2.body:getY())
    elseif power2 == 3 then
  love.graphics.draw(p3c, objects.ball2.body:getX(), objects.ball2.body:getY())
      elseif power2 == 4 then
  love.graphics.draw(p4c, objects.ball2.body:getX(), objects.ball2.body:getY())
        elseif power2 == 5 then
  love.graphics.draw(p5c, objects.ball2.body:getX(), objects.ball2.body:getY())
  elseif power2 == 6 then
      love.graphics.draw(p6c, objects.ball2.body:getX(), objects.ball2.body:getY())
      end
end
end
end

function powerswitchf(fe)
  if fe == 1 then
  if power1 < 6 then
    power1 = power1 + 1
    elseif power1 == 6 then
      power1 = 1
    end
    if power1 == 1 then
      powert = "Bullets"
      elseif power1 == 2 then
        powert = "blink"
        elseif power1 == 3 then
          powert = "freeze"
          elseif power1 == 4 then
            powert = "zoom"
            elseif power1 == 5 then
              powert = "switch"
              elseif power1 == 6 then
                powert = "teleport"
    end
  end
  if fe == 2 then
      if power2 < 6 then
    power2 = power2 + 1
    elseif power2 == 6 then
      power2 = 1
    end
    if power2 == 1 then
      powere = "Bullets"
      elseif power2 == 2 then
        powere = "blink"
        elseif power2 == 3 then
          powere = "freeze"
          elseif power2 == 4 then
            powere = "zoom"
            elseif power2 == 5 then
              powere = "switch"
              elseif power2 == 6 then
                powere = "teleport"
    end
  end
end
pai = math.random(2, 6)
function ai()
  cont2 = 5
pb = objects.ball.body:getX()
ab = objects.ball2.body:getX()
  if pb > ab and aim == 0 then
          b2d = 800 
      b2e = -75
    b2d = -800
    b2e = 75
    objects.ball2.body:applyForce(posspeed2, 0)
  end
    if pb < ab and aim == 0 then
      b2d = -800
    b2e = 75
      objects.ball2.body:applyForce(negspeed2, 0)
    end
    if cooldown2 == 0 and aim == 0 then
      aip = math.random(0, 200)
      if aip == 137 then
      if pai == 2 then
      blink(2)
      elseif pai == 3 then
        freeze(1)
        elseif pai == 4 then
          zoom(2)
          elseif pai == 5 then
            switch(2)
            elseif pai == 6 then
              teleport(2)
    end
      end
    end
    aijump = math.random(0,2)
    if aijump == 1 and aim == 0 then
          contacts2 = objects.ball2.body:getContactList()

    if table.getn(contacts2) > 0 then
      objects.ball2.body:applyForce(0, -1250)
    end
    end
end

function drawninvis()
  love.graphics.setColor(72, 160, 14)
  love.graphics.polygon("fill", objects.ground.body:getWorldPoints(objects.ground.shape:getPoints()))

  love.graphics.setColor(50, 50, 50)
  love.graphics.polygon("fill", objects.wall2.body:getWorldPoints(objects.wall2.shape:getPoints()))
  love.graphics.polygon("fill", objects.wall1.body:getWorldPoints(objects.wall1.shape:getPoints()))
end

function endGame()
	Menu = true
	--`objects = {}
	guiG:show()
	allBullets = {}
end

function cloop()
  if r > 255 then
    r = 0
  end
  if g > 255 then
    g = 0
  end
  if b > 255 then
    b = 0
  end
end

function love.load()
  r = 255
  g = 0
  b = 0
    Winner = ""
	loadGame()
      if power1 == 1 then
      powert = "Bullets"
      elseif power1 == 2 then
        powert = "blink"
        elseif power1 == 3 then
          powert = "freeze"
          elseif power1 == 4 then
            powert = "zoom"
            elseif power1 == 5 then
              powert = "switch"
              elseif power1 == 6 then
                powert = "teleport"
    end
    if power2 == 1 then
      powere = "Bullets"
      elseif power2 == 2 then
        powere = "blink"
        elseif power2 == 3 then
          powere = "freeze"
          elseif power2 == 4 then
            powere = "zoom"
            elseif power2 == 5 then
              powere = "switch"
              elseif power2 == 6 then
                powere = "teleport"
    end
    udp = socket.udp()
    p1 = love.graphics.newImage("bullet.png")
    p1c = love.graphics.newImage("bullet.png")
    p4c = love.graphics.newImage("zoomcharging.png")
        p4 = love.graphics.newImage("zoomready.png")
        p2 = love.graphics.newImage("blinkready.png")
                p2c = love.graphics.newImage("blinkcharging.png")
                p3 = love.graphics.newImage("freezeready.png")
                p3c = love.graphics.newImage("freezecharging.png")
                p5c = love.graphics.newImage("switchcharging.png")
                p5 = love.graphics.newImage("switchready.png")
                p6 = love.graphics.newImage("teleportready.png")
                p6c = love.graphics.newImage("teleportcharging.png")
	guiG = gui:group(false, {0, 0, 0, 0})
      custommenu = gui:group(false, {love.graphics.getWidth()-400, love.graphics.getHeight()-400, 400, 700})
      custommenu.drag = true
    love.window.setFullscreen(true, 'desktop')
      PowerSwitch = gui:button("Player1: "..powert, {20, 20, 160, 50}, custommenu)
            PowerSwitch2 = gui:button("Player2: "..powere, {190, 20, 160, 50}, custommenu)
      exitc = gui:button("X", {370, 0, 30, 30}, custommenu)
    exitc.style.default = {239, 69, 69}
    exitc.style.hilite = {239, 69, 69}
    exitc.style.focus = {183, 55, 55}
    exitc.style.font = love.graphics.newFont(10)
    ballgui = gui:button("", {140, 120, 130, 120}, custommenu)
    Rcustom = gui:button("R: "..r, {20, 270, 325, 50}, custommenu)
    Gcustom = gui:button("G: "..g, {20, 340, 325, 50}, custommenu)
    Bcustom = gui:button("B: "..b, {20, 410, 325, 50}, custommenu)
    custommenu:hide()
    LastWinner = gui:text("Last Winner: ", {love.graphics.getWidth() / 2 - (496/2), love.graphics.getHeight() - 86, 496, 64}, guiG)
    LastWinner.style.font = love.graphics.newFont(40)
	exitb = gui:text("", {love.graphics.getWidth() - 40, 10, 50, 50}, guiG)
	exitb.style.default = {255, 255, 255}
	exit = gui:button("X", {love.graphics.getWidth()-60, 0, 60, 60}, guiG)
    exit.style.default = {239, 69, 69}
    exit.style.hilite = {239, 69, 69}
    exit.style.focus = {183, 55, 55}
    exit.style.font = love.graphics.newFont(60)
	Gamemodes = gui:text('Gamemodes', {love.graphics.getWidth() / 2 - 128, 80, 200, 200}, guiG)
	Gamemodes.style.font = love.graphics.newFont(30)
	underline = gui:text("__________________", {love.graphics.getWidth() / 2 - 130, 85, 250, 200}, guiG)
		underline.style.font = love.graphics.newFont(30)
  button = gui:button('Local', {love.graphics.getWidth() / 2 - 128, 128, 256, 64}, guiG)
  button.style.default = {98, 136, 248}
  button.style.hilite = {98, 136, 248}
    button.style.focus = {54, 136, 248}
  button.style.font = love.graphics.newFont(60)
  button:setshape("rect")
    buttonai = gui:button('AI', {love.graphics.getWidth() / 2 - 128, 256 + 256, 256, 64}, guiG)
  buttonai.style.default = {98, 136, 248}
  buttonai.style.hilite = {98, 136, 248}
    buttonai.style.focus = {54, 136, 248}
  buttonai.style.font = love.graphics.newFont(60)
  buttonai:setshape("rect")
    button3 = gui:button('Invisible', {love.graphics.getWidth() / 2 - 128, 256 + 64, 256, 64}, guiG)
  button3.style.default = {98, 136, 248}
  button3.style.hilite = {98, 136, 248}
    button3.style.focus = {54, 136, 248}
  button3.style.font = love.graphics.newFont(50)
  button3:setshape("rect")
      button4 = gui:button('No Powers', {love.graphics.getWidth() / 2 - 128, 256 + 168, 256, 64}, guiG)
  button4.style.default = {98, 136, 248}
  button4.style.hilite = {98, 136, 248}
    button4.style.focus = {54, 136, 248}
  button4.style.font = love.graphics.newFont(50)
  button4:setshape("rect")
  button2 = gui:button('Online', {love.graphics.getWidth() / 2 - 128, 222, 256, 64}, guiG)
  button2.style.default = {98, 136, 248}
  button2.style.hilite = {98, 136, 248}
    button2.style.focus = {54, 136, 248}
  button2.style.font = love.graphics.newFont(60)
  button2:setshape("rect")
  exit:setshape("rect")
  ballgui:setshape("circle")
    custombutton = gui:button("Customisation", {50, 0, 356, 84}, guiG)
      custombutton.style.default = {98, 136, 248}
    custombutton.style.hilite = {98, 136, 248}
    custombutton.style.focus = {54, 136, 248}
  custombutton.style.font = love.graphics.newFont(50)
  ballgui.style.hilite = {r, g, b}
  ballgui.style.focus = {r, g, b}
  button.click = function(this) startGame(0) end
  exit.click = function(this) love.event.quit() saveGame() end
  button2.click = function(this) gui:feedback("coming soon") end
  button3.click = function(this) startGame(2)end
  button4.click = function(this) startGame(3)end
  buttonai.click = function(this) startGame(4)end
  PowerSwitch.click = function(this) powerswitchf(1) PowerSwitch.label = "Player1: "..powert end
    PowerSwitch2.click = function(this) powerswitchf(2) PowerSwitch2.label = "Player2: "..powere end
  exitc.click = function(this) custommenu:hide() end
  custombutton.click = function(this) custommenu:show() end
  Rcustom.click = function(this) r = r + 5 cloop() Rcustom.label = "R: "..r ballgui.style.hilite = {r, g, b} ballgui.style.focus = {r, g, b} cloop() end
  Gcustom.click = function(this) g = g + 5 cloop() Gcustom.label = "G: "..g ballgui.style.hilite = {r, g, b} ballgui.style.focus = {r, g, b} cloop() end
  Bcustom.click = function(this) b = b + 5 cloop() Bcustom.label = "B: "..b ballgui.style.hilite = {r, g, b} ballgui.style.focus = {r, g, b} cloop() end
 
  --initial graphics setup
  love.graphics.setBackgroundColor(104, 136, 248)
end
 
 allBullets = {}

 function createbullet(x, y)
    bullet = {}
    bullet.body = love.physics.newBody(world, x, y, "dynamic")
    bullet.shape = love.physics.newCircleShape(10)
    bullet.fixture = love.physics.newFixture(bullet.body, bullet.shape, 1)
    bullet.fixture:setRestitution(1.25765)

    table.insert(allBullets, bullet)

    return bullet
 end

 b1d = 800
 b2d = -800
 b1e = 75
 b2e = 75
 cooldown1 = 0
 cooldown2 = 0
 cont1 = 0
cont2 = 0
zoom1 = 0
zoom2 = 0
 function blink(player)
x2 = objects.ball2.body:getX()
x1 = objects.ball.body:getX()
      if player == 1 and cooldown1 == 0 then
        objects.ball.body:setX(x1+b1d)
              cooldown1 = 800
      end
      if player == 2 and cooldown2 == 0 then
        objects.ball2.body:setX(x2+b2d)
              cooldown2 = 800
      end
 end

function freeze(target)
  if target == 1 and cooldown2 == 0 then
    cont1 = 100
    aim = 100
    cooldown2 = 800
  end
  if target == 2 and cooldown1 == 0 then
      cont2 = 100
      cooldown1 = 800
    end
end

function zoom(player)
  if player == 1 and cooldown1 == 0 then
    posspeed1 = 420
    negspeed1 = -420
    zoom1 = 600
    cooldown1 = 800 
  end
   if player == 2 and cooldown2 == 0 then
    posspeed2 = 420
    negspeed2 = -420
    zoom2 = 600
    cooldown2 = 800 
  end 
end

function switch(player)
  p1x = objects.ball.body:getX()
  p1y = objects.ball.body:getY()
  p2x = objects.ball2.body:getX()
  p2y = objects.ball2.body:getY()
  if player == 1 and cooldown1 == 0 then
    objects.ball.body:setX(p2x)
    objects.ball.body:setY(p2y)
    objects.ball2.body:setX(p1x)
    objects.ball2.body:setY(p1y)
    cooldown1 = 800
    elseif player == 2 and cooldown2 == 0 then
    objects.ball2.body:setX(p1x)
    objects.ball2.body:setY(p1y)
    objects.ball.body:setX(p2x)
    objects.ball.body:setY(p2y)
    cooldown2 = 800
    end
end

function teleport(player)
  x, y = love.mouse.getPosition( )
  if player == 1 and cooldown1 == 0 then
    objects.ball.body:setPosition(x, y)
    cooldown1 = 800
    elseif player == 2 and cooldown2 then
    objects.ball2.body:setPosition(x, y)
    cooldown2 = 800
    end
end

function love.update(dt)
    if cont1 ~= 0 then
    cont1 = cont1 - 1
end
    if aim ~= 0 then
      aim = aim - 1
  end
  if Menu == false then
  world:update(dt)
end
  gui:update(dt)
  if Menu == true and Winner ~= "" then
    LastWinner.label = "Last Winner: "..Winner 
  end
  while table.getn(allBullets) > 100 do -- Keep deleting bullets until there are 100 or less.
     bulletToDelete = allBullets[1] -- Get the earliest bullet created.

        bulletToDelete.fixture:destroy() -- Destroy the bullet in the physics engine.
        bulletToDelete.body:destroy()

        table.remove(allBullets, 1) -- Delete the bullet from the allBullets list so that we don't try to draw it.
    end
    if Menu == false then
     distance1 = love.physics.getDistance(objects.wall1.fixture, objects.ball.fixture)

    if distance1 < 20 then
        objects.ball.body:applyForce(2000 * (1 - distance1 / 20), 0)
    end
         distance2 = love.physics.getDistance(objects.wall2.fixture, objects.ball.fixture)

    if distance2 < 20 then
        objects.ball.body:applyForce(-2000 * (1 - distance2 / 20), 0)
    end
         distance3 = love.physics.getDistance(objects.wall1.fixture, objects.ball2.fixture)

    if distance3 < 20 then
        objects.ball2.body:applyForce(2000 * (1 - distance3 / 20), 0)
    end
         distance4 = love.physics.getDistance(objects.wall2.fixture, objects.ball2.fixture)

    if distance4 < 20 then
        objects.ball2.body:applyForce(-2000 * (1 - distance4 / 20), 0)
    end
             distance5 = love.physics.getDistance(objects.ball.fixture, objects.ball2.fixture)

    if distance5 < 20 then
        objects.ball2.body:applyForce(0, 2000 * (1 - distance5 / 20))
               objects.ball.body:applyForce(0, 2000 * (1 - distance5 / 20))
    end
end
  --objects.wall1.body:setPosition(0,300)
    --objects.wall2.body:setPosition(love.graphics.getWidth(),300)
    --objects.wall1.body:setAngle(0)
        --objects.wall2.body:setAngle(0)
        if not love.keyboard.isDown("space") and not love.keyboard.isDown("m") and table.getn(allBullets) > 50 then
        	bulletToDelete = allBullets[1] -- Get the earliest bullet created.

        bulletToDelete.fixture:destroy() -- Destroy the bullet in the physics engine.
        bulletToDelete.body:destroy()

        table.remove(allBullets, 1)
        end
 
    --if love.keyboard.isDown("escape")then
    --	saveGame()
    --  love.event.quit()
    --end
    rankingpoints = Wins - Loses
    if Menu == false then
      if cooldown1 ~= 0 then
        cooldown1 = cooldown1 - 1
      end
        if cont2 ~= 0 then
    cont2 = cont2 - 1
end
if zoom1 ~= 0 then
  zoom1 = zoom1 - 1
  elseif zoom1 == 0 then
  posspeed1 = 350
  negspeed1 = -350
end
if zoom2 ~= 0 then
  zoom2 = zoom2 - 1
elseif zoom2 == 0 then
  posspeed2 = 350
  negspeed2 = -350
end
            if cooldown2 ~= 0 then
        cooldown2 = cooldown2 - 1
      end
    	love.window.setTitle("BetaBashers")
    	    if objects.ball.body:getY() > love.graphics.getHeight() then
    	endGame()
    	Winner = "Player2"
    elseif objects.ball2.body:getY() > love.graphics.getHeight() then
    	endGame()
    	Winner = "Player1"
    end
              if objects.ball.body:getY() < -2870 then
      endGame()
      Winner = "Player2"
    elseif objects.ball2.body:getY() < -2870 then
      endGame()
      Winner = "Player1"
    end
    	if love.keyboard.isDown("d") and cont1 == 0 then
      b1d = 800
      b1e = 75
    objects.ball.body:applyForce(posspeed1, 0)
  end
  if love.keyboard.isDown("a") and cont1 == 0 then
    b1d = -800
    b1e = -75
    objects.ball.body:applyForce(negspeed1, 0)
  end
  if love.keyboard.isDown("w") and cont1 == 0 then
    contacts1 = objects.ball.body:getContactList()

    if table.getn(contacts1) > 0 then
      objects.ball.body:applyForce(0, -1250)
    end
  end
        if love.keyboard.isDown('space') and Mode ~= 3 and cont1 == 0 then
      if power1 == 1 then
      local x, y = objects.ball.body:getPosition()
      bullet = createbullet(x + b1e, y)      
      bullet.body:setLinearVelocity(b1d, 0)
      cooldown1 = 30
            elseif power1 == 2 then
      blink(1)
      elseif power1 == 3 then
        freeze(2)
        elseif power1 == 4 then
          zoom(1)
          elseif power1 == 5 then
            switch(1)
            elseif power1 == 6 then
              teleport(1)
    end
end

    if love.keyboard.isDown("right") and cont2 == 0 then
      b2d = 800
      b2e = -75
    objects.ball2.body:applyForce(posspeed2, 0)
  end
  if love.keyboard.isDown("left") and cont2 == 0 then
    b2d = -800
    b2e = 75
    objects.ball2.body:applyForce(negspeed2, 0)
  end
  if love.keyboard.isDown("up") and cont2 == 0 then
    contacts2 = objects.ball2.body:getContactList()

    if table.getn(contacts2) > 0 then
      objects.ball2.body:applyForce(0, -1250)
    end
  end
    if love.keyboard.isDown('m') and Mode ~= 3 and cont2 == 0 then
      if power2 == 1 then
      local x, y = objects.ball2.body:getPosition()
      bullet = createbullet(x - b2e, y)
      bullet.body:setLinearVelocity(b2d, 0)
      cooldown2 = 30
      elseif power2 == 2 then
      blink(2)
      elseif power2 == 3 then
        freeze(1)
        elseif power2 == 4 then
          zoom(2)
          elseif power2 == 5 then
            switch(2)
            elseif power2 == 6 then
              teleport(2)
    end
  end
  if Mode == 4 then
  ai()
end
    else
    	love.window.setTitle("BetaBashersLauncher")
    		allBullets = {}
    		objects = {}
        cooldown2 = 0
        cooldown1 = 0
        cont1 = 0
        cont2 = 0
  end
end


function love.draw()
  --love.graphics.print(cont2, 50, 50)
  --x, y = objects.ball2.body:getLinearVelocity()
  --love.graphics.print(y, 0, 0)

  --width = love.graphics.getWidth( )
  --love.graphics.print(width, 0, 0)
  if Menu == false then
    if Mode ~= 2 then
      drawnorm()
      elseif Mode == 2 then
      drawninvis()
      end
end
  for bulletIndex, bullet in pairs(allBullets) do
        love.graphics.setColor(255, 255, 255)
        love.graphics.circle("fill", bullet.body:getX(), bullet.body:getY(), bullet.shape:getRadius())
    end
gui:draw()
end
love.mousepressed = function(x, y, button)
  gui:mousepress(x, y, button)
end
love.mousereleased = function(x, y, button)
  gui:mouserelease(x, y, button)
end
love.wheelmoved = function(x, y)
  gui:mousewheel(x, y)
end